/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package chapter45;

import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.jws.WebParam;

import chapter42.Address; 
import java.sql.*;
import javax.jws.WebMethod; 
import javax.jws.WebService;

/**
 *
 * @author manal
 */

@WebService(name = "AddressService", serviceName = "AddressWebService")

public class AddressService {

    /**
     * This is a sample web service operation
     */
    @WebMethod(operationName = "hello")
    public String hello(@WebParam(name = "name") String txt) {
        return "Hello " + txt + " !";
    }
    
    // statement1 for retrieving an address and statement2 for storing 
    private PreparedStatement statement1;
    // statement2 for storing an address 
    private PreparedStatement statement2;
    public AddressService() { 
        initializeJdbc();
    }
    @WebMethod(operationName = "getAddress")
    public Address getAddress(String firstName, String lastName) { 
        try {
            statement1.setString(1, firstName); 
            statement1.setString(2, lastName);
            ResultSet resultSet = statement1.executeQuery();
            if (resultSet.next()) {
                Address address = new Address(); 
                address.setFirstName(resultSet.getString("firstName")); 
                address.setLastName(resultSet.getString("lastName")); 
                address.setMi(resultSet.getString("mi")); 
                address.setTelephone(resultSet.getString("telephone")); 
                address.setFirstName(resultSet.getString("email")); 
                address.setCity(resultSet.getString("telephone")); 
                address.setState(resultSet.getString("state")); 
                address.setZip(resultSet.getString("zip"));
                return address;
            } 
            else
                return null;
        } 
        catch (SQLException ex) {
            ex.printStackTrace();
        } 
        return null;
    }
    
    @WebMethod(operationName = "storeAddress")
    public void storeAddress(Address address) { 
        try {
            statement2.setString(1, address.getLastName()); 
            statement2.setString(2, address.getFirstName()); 
            statement2.setString(3, address.getMi()); 
            statement2.setString(4, address.getTelephone()); 
            statement2.setString(5, address.getEmail()); 
            statement2.setString(6, address.getStreet()); 
            statement2.setString(7, address.getCity()); 
            statement2.setString(8, address.getState()); 
            statement2.setString(9, address.getZip()); 
            statement2.executeUpdate();
        } 
        catch (SQLException ex) { 
            ex.printStackTrace();
        } 
    } 

    /** Initialize database connection */ 
    public void initializeJdbc() {
        try { 
            //Class.forName("com.mysql.jdbc.Driver");
            Class.forName("org.sqlite.JDBC");
            
            // Connect to the sample database
            //Connection connection = DriverManager.getConnection("jdbc:mysql://localhost/javabook", "scott", "tiger");
            Connection connection = DriverManager.getConnection("jdbc:sqlite:javabook.db");
            Statement statement = connection.createStatement();
            statement.executeUpdate (
                "create table Address (lastName varchar(25), firstName varchar(25),mi char(1), " +
                " telephone char(11), email varchar(50), street varchar(50), city varchar(10), state varchar(10), zip varchar(10));"
            );
                    
            statement1 = connection.prepareStatement("select * from Address where firstName = ? and lastName = ?");
            statement2 = connection.prepareStatement( "insert into Address " +
                        "(lastName, firstName, mi, telephone, email, street, city, " + 
                        "state, zip) values (?, ?, ?, ?, ?, ?, ?, ?, ?)");
              } 
        catch (Exception ex) {
            ex.printStackTrace();
        } 
    }  


}
